routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['as' => 'web.'], function () {
    
    Route::get('/', 'LandingController@home')->name('home');
    Route::get('find-us', 'LandingController@find_us')->name('find_us');
    Route::get('contact', 'LandingController@contact')->name('contact');
    Route::get('about', 'LandingController@about')->name('about');
    Route::get('size', 'LandingController@size')->name('size');
    Route::get('shipping', 'LandingController@shipping')->name('shipping');
    Route::get('policy', 'LandingController@policy')->name('policy');
    Route::get('tos', 'LandingController@tos')->name('tos');
    Route::get('faq', 'LandingController@faq')->name('faq');
    
    
    Route::get('product/{category}', 'LandingController@category')->name('category');
    Route::get('product/{category}/{product}', 'LandingController@product')->name('product');
    Route::get('product/', 'LandingController@search')->name('product.search');

    Route::get('cart', 'LandingController@cart')->name('cart');
    Route::post('cart', 'LandingController@storeCart')->name('cart.store');

    Route::get('/content/color/image/{id}', 'LandingController@showColorImage');
    Route::get('/content/showcase/image/{id}', 'LandingController@showShowcaseImage')->name('showcase.image');
    Route::get('/content/showcase/image/detail/{id}', 'LandingController@showShowcaseDetailImage')->name('showcase.detail.image');
    Route::get('/content/popup/image/{id}', 'LandingController@showPopupImage')->name('popup.image');
    Route::get('/content/product/{id}/imagecolor', 'LandingController@showProductColorImage');
    Route::get('/content/product/{id}/image', 'LandingController@showProductImage');

    Route::get('testemail', 'EmailController@testMail')->name('testMail');

    Route::post('/message/send', 'LandingController@sendMessage')->name('contact_us');

});

Auth::routes();

Route::get('checkout', 'LandingController@checkout')->name('checkout');
Route::post('checkout', 'CartController@doCheckout')->name('checkout.store');
Route::get('payment', 'LandingController@payment')->name('payment');

Route::get('/cart/voucher', 'CartController@getVoucher')->name('voucher.check');
Route::get('/cart/voucher/remove', 'CartController@removeVoucher'); 

Route::post('/subscribe/email', 'LandingController@subscribeEmail')->name('subscribe.store');
Route::post('/disc_request', 'LandingController@discountRequest')->name('discount.request');


/**
 * Route to get region
 */
Route::get('/get-regions/city/db', 'RegionController@getCityFromDb')->name('region.get_city.db');
Route::get('/get-regions/subdistrict/db', 'RegionController@getSubDistrictFromDb')->name('region.get_subdistrict.db');

Route::post('/get-regions/city/external', 'RegionController@getCity')->name('region.get_city');
Route::post('/get-regions/subdistrict/external', 'RegionController@getSubDistrict')->name('region.get_subdistrict');
Route::post('/get-regions/cost', 'RegionController@getCost')->name('region.get_cost');


Route::group(['prefix' => 'dashboard','as' => 'dashboard.'], function () {
    Route::get('/', 'DashboardController@home')->name('home');
    Route::get('/profile', 'DashboardController@profile')->name('profile');
    Route::put('/profile', 'DashboardController@updateProfile')->name('profile.update');
    Route::put('/update/password', 'DashboardController@updatePassword')->name('password.update');
    Route::get('/address', 'DashboardController@address')->name('address');
    Route::put('/address', 'DashboardController@updateAddress')->name('address.update');
});

Route::post('checkstock', 'LandingController@checkStock');
Route::get('login/{provider}/social', 'Auth\LoginController@redirectToProvider')->name('login.social');
Route::get('login/{provider}/callback', 'Auth\LoginController@handleProviderCallback');

Auth::routes();

/*
 * Payment Gateway
 */
// Veritrans notification
Route::post('/api/payment/notif/veritrans', 'PaymentController@notifVeritrans');



/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['prefix' => 'admin', 'namespace' => 'Admin'], function ()
{
    Route::get('/', 'HomeController@index');

    Route::get('/auth/login', 'AuthController@getLogin');
    Route::get('/auth/logout', 'AuthController@getLogout');
    Route::get('/auth/password/change', 'AuthController@getChangePassword');
    
    Route::post('/auth/login', 'AuthController@postLogin');
    Route::post('/auth/password/change', 'AuthController@postChangePassword');

    //product 
    Route::get('/product', 'ProductController@index');

    Route::get('/product/create', [
    	//'middleware' => 'auth.app.product',
    	'uses' => 'ProductController@create'
		]);
    Route::get('/product/{id}', [
            //'middleware' => 'auth.app.product',
            'uses' => 'ProductController@edit'
            ]);

    Route::post('/product/create', [
            //'middleware' => 'auth.app.product',
            'uses' => 'ProductController@store'
            ]);
    Route::post('/product/{id}', [
            //'middleware' => 'auth.app.product',
            'uses' => 'ProductController@update'
            ]);

    /*
    * Productsize
    */
    Route::get('/productsize', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductsizeController@index'
        ]);

    Route::post('productsize', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductsizeController@store'
        ]);
    Route::post('productsize/{id}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductsizeController@update'
        ]);
    Route::post('/productsize/{id}/delete', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductsizeController@delete'
        ]);
    Route::post('productsize/{id}/move/{move}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductsizeController@move'
        ]);


    /*
    * ProductColor
    */
    Route::get('productcolor/create/{id?}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductColorController@create'
        ]);
    Route::get('productcolor/{id?}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductColorController@index'
        ]);
    Route::get('productcolor/{id}/edit', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductColorController@edit'
        ]);

    Route::post('productcolor', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductColorController@store'
        ]);
    Route::post('productcolor/{id}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductColorController@update'
        ]);
    Route::post('productcolor/{id}/delete', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductColorController@delete'
        ]);

    /*
    * ProductStock
    */
    Route::get('productstock/{id?}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductStockController@index'
        ]);

    Route::post('productstock/{id?}/update', [
        //'middleware' => 'auth.app.product',
        'uses' => 'ProductStockController@update'
        ]);
    /*
    * Media
    */
    Route::get('/media', [
        //'middleware' => 'auth.app.product',
        'uses' => 'MediaController@index'
        ]);

    Route::post('media/create', [
        //'middleware' => 'auth.app.product',
        'uses' => 'MediaController@store'
        ]);
    Route::post('media/{id}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'MediaController@update'
        ]);
    Route::post('media/{id}/delete', [
        //'middleware' => 'auth.app.product',
        'uses' => 'MediaController@delete'
        ]);

    /*
    * Category
    */
    Route::get('/category', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@index'
        ]);

        Route::get('/category/create', [
            //'middleware' => 'auth.app.product',
            'uses' => 'CategoryController@create'
            ]);
    
        Route::post('/category/create', [
            //'middleware' => 'auth.app.product',
            'uses' => 'CategoryController@store'
            ]);
    Route::get('/category/{id}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@edit'
        ]);

    Route::post('/category/{id}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@update'
        ]);
    
    Route::post('/category/{id}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@update'
        ]);
    Route::post('/category/{id}/move/{move}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@move'
        ]);

    Route::post('/category/{id}/add', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@addSubcategory'
        ]);
    Route::post('/category/{id}/update/{subId}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@updateSubcategory'
        ]);
    Route::post('/category/{id}/delete/{subId}', [
        //'middleware' => 'auth.app.product',
        'uses' => 'CategoryController@deleteSubcategory'
        ]);


         /*
    * City Store
    */

app/Models/City.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use App\Models\Province;

class City extends Model
{
    protected $primaryKey = 'city_id';

    protected $fillable = [
        'city_id', 'province_id', 'type', 'city_name', 'postal_code'
    ];

    public function users() {
        return $this->hasMany('App\ModelsUser', 'city_id', 'city_id');
    }

    public function province() {
        return $this->belongsTo('App\Models\Province', 'province_id', 'province_id');
    }

    public function sub_districts() {
        return $this->hasMany('App\Models\SubDistrict', 'city_id', 'city_id');
    }

    /**
     * Start of mutator function
     */

    public function getFullNameAttribute() {
        $fullName = $this->attributes['city_name'];
        if ($this->attributes['type'] != 'Kota') {
            $fullName = $this->attributes['type'] . ' ' . $fullName;
        }
        return $fullName;
    }

    public function getNameWithProvinceAttribute() {
        $city = $this->getFullNameAttribute();

        $cityWithProvince = $city . ', ' . $this->province->province;

        return $cityWithProvince;
    }

    /**
     * End of mutator function
     */

}

resources/views/user/address.blade.php
@extends('layouts.web')

@section('content')
    @include('user.components.nav_menu')
    <div class="p-4">
        @if (session('address-updated'))
        <div class="alert alert-primary alert-dismissible fade show" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                <span class="sr-only">Close</span>
            </button>
            {{ session('address-updated') }}
        </div>
        @endif
        <h5 class="font-weight-bold mb-3">Shipping Address</h5>
        <div>
            <span class="text-muted">Alamat</span>
            <p>{{ $customer->address != null ? $customer->address : '-'}}</p>
        </div>
        <div>
            <span class="text-muted">Town / City</span>
            <p>{{ $customer->city != null ? $customer->cityb->type . ' ' . $customer->cityb->city_name : '-'}}</p>
        </div>
        <div>
            <span class="text-muted">Sub-district</span>
            <p>{{ $customer->sub_district != null ? $customer->sub_districtb->subdistrict_name : '-'}}</p>
        </div>
        <div>
            <span class="text-muted">Sub-district</span>
            <p>{{  $customer->province != null ? $customer->provinceb->province : '-'}}</p>
        </div>
        <div>
            <span class="text-muted">Postcode / ZIP</span>
            <p>{{ $customer->postal_code != null ? $customer->postal_code : '-'}}</p>
        </div>
        <a href="#" class="btn btn-warning" data-toggle="modal" data-target="#edit-address"><i class="fas fa-edit"></i> Edit Address</a>
    </div>
@endsection

@push('modal')

<!-- View Detail -->
<div class="modal fade" id="edit-address" tabindex="-1" role="dialog" aria-labelledby="modelTitleId" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content p-4">
            <div class="modal-header border-0 p-0 pb-4">
                <div class="w-100">
                    <div class="row">
                        <div class="col-lg-9 mr-auto">
                            <h3 class="modal-title font-weight-bold">Edit Address</h3>
                        </div>
                        <div class="col-lg-2 text-right">
                            <button type="button" class="close py-2" data-dismiss="modal" aria-label="Close">
                                <i class="fas fa-times"></i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-body p-0">
                <loading-component v-if="showLoading"></loading-component>
                <div class="row">
                    <div class="col-lg-12">
                        <div class="alert alert-secondary">
                            Make sure the address field you enter is complete
                        </div>
                    </div>
                </div>
                <form action="{{ route('dashboard.address.update') }}" method="POST">
                    @csrf 
                    <input type="hidden" name="_method" value="PUT">
                    <div class="form-group">
                        <label for="" class="text-muted">Street Address</label>
                        <textarea name="address" class="form-control" cols="30" rows="3">{{ Auth::user()->address }}</textarea>
                    </div>
                    <div class="form-group row required">
                        <div class="col-md-6">
                            <label for="">Country / Region</label>
                            <select name="province" class="form-control form-control-lg" v-model="province" @change="selectCity" id="province">
                                @foreach( getProvinceForInsert() as $id => $province)
                                <option value="{{ $id }}" 
                                    @auth @if($id == Auth::user()->province) selected @endif @endauth>{{ $province }} 
                                </option>
                                @endforeach
                            </select>
                            {{-- <small id="helpId" class="form-text text-muted">Help text</small> --}}
                        </div>
                        <div class="col-md-6">
                            <label for="">Town / City</label>
                            <select name="city" class="form-control form-control-lg" v-model="city" id="city" @change="selectDistrict">
                                <option v-cloak v-if="cities.length > 0" :value="city.city_id" v-for="city in cities" :key="city.city_id">@{{ city.type + ' ' +city.city_name }}</option>
                                <option v-cloak v-else value="">-- Select City --</option>
                            </select>
                            {{-- <small id="helpId" class="form-text text-muted">Help text</small> --}}
                        </div>
                    </div>
                    <div class="form-group row required">
                        <div class="col-md-6">
                            <label for="">Sub-district</label>
                            <select name="district" class="form-control form-control-lg" v-model="district" id="district">
                                <option v-cloak v-if="districts.length > 0" :value="district.subdistrict_id" v-for="(district, key) in districts" :key="district.subdistrict_id">@{{ district.subdistrict_name }}</option>
                                <option v-cloak v-else value="">-- Select District --</option>
                            </select>
                            {{-- <small id="helpId" class="form-text text-muted">Help text</small> --}}
                        </div>
                        <div class="col-md-6">
                            <label for="">Post Code / ZIP</label>
                            <input type="text" name="postal_code" class="form-control form-control-lg" value="@auth {{ Auth::user()->postal_code }} @endauth" placeholder="Post Code">
                            {{-- <small id="helpId" class="form-text text-muted">Help text</small> --}}
                        </div>
                    </div>
                    <button class="btn btn-block btn-lg btn-warning">Save Change</button>
                </form>
            </div>
        </div>
    </div>
</div>

@endpush

<script type="text/javascript">
    window.currentAddress = JSON.stringify({
        province: '{{ Auth::user()->province }}',
        city: '{{ Auth::user()->city }}',
        district: '{{ Auth::user()->sub_district }}'
    });
</script>
@push('scripts')

resources/views/user/home.blade.php
@extends('layouts.web')

@section('content')
    @include('user.components.nav_menu')
    <div class="p-4">
        <div class="row">
            <div class="col-lg-3">
                <div class="input-group mb-4">
                    <form action="{{ route('dashboard.home') }}" method="GET">
                        @csrf
                    <input type="text" name="keyword" id="keyword" class="form-control" placeholder="Find your invoice code" aria-describedby="prefixId">
                    {{-- <div class="input-group-append">
                        <button class="btn btn-secondary"><i class="fas fa-search"></i></button>
                    </div> --}}
                </form>
                </div>
            </div>
        </div>
        <div class="d-flex flex-nowrap align-items-center mb-4">
            <span class="font-weight-bold">Filter Status :</span>
            <div class="filter-cat">
                <a href="{{ route('dashboard.home', array_merge(request()->all(), ['status' =>  'all'])) }}" class="{{ $status == 'all' ? "active" : "" }}">All Purchase</a>
                <a href="{{ route('dashboard.home', array_merge(request()->all(), ['status' =>  'INV'])) }}" class="{{ $status == 'INV' ? "active" : "" }}">Waiting Payment</a>
                <a href="{{ route('dashboard.home', array_merge(request()->all(), ['status' =>  'PAI'])) }}" class="{{ $status == 'PAI' ? "active" : "" }}">Confirmed</a>
                <a href="{{ route('dashboard.home', array_merge(request()->all(), ['status' =>  'WRK'])) }}" class="{{ $status == 'WRK' ? "active" : "" }}">Processed</a>
                <a href="{{ route('dashboard.home', array_merge(request()->all(), ['status' =>  'DLV'])) }}" class="{{ $status == 'DLV' ? "active" : "" }}">On Delivery</a>
                {{-- <a href="#">Completed</a> --}}
            </div>
        </div>
        <div class="table-zn">
            <div class="table-zn__body">

                @foreach($transactions as $transaction)
                <div class="table-zn__row">
                    <div class="col-5 col-lg-1">
                        <img src="{{ action('LandingController@showProductImage', [$transaction->items->first()->product->images->first()->id]) }}" class="img-fluid" alt="">
                    </div>
                    <div class="col-7 col-lg-11">
                        <div class="row mb-2">
                            <div class="col-12 col-md-8">
                                <span>{{ $transaction->order_number }}</span>
                            </div>
                            {{-- <div class="col-4 text-right">
                                <a href="javascript:void(0)" class="text-muted">Batalkan Transaksi</a>
                            </div> --}}
                        </div>
                        <div class="row">
                            <div class="col-12 col-md-4">
                                <span class="text-muted">Total : <span class="text-warning font-weight-bold">{{ i18l_currency($transaction->total) }}</span></span>
                                <p><span class="text-muted">Tanggal Pembelian</span> {{ \Carbon\Carbon::parse($transaction->created_at)->format('d M Y')}}</p>
                            </div>
                            <div class="col-12 col-md-3">
                                <span class="text-muted">Status :</span>
                                @if($transaction->state == 'INV')
                                    <p class="text-warning">Waiting Payment</p>
                                @elseif($transaction->state == 'PAI')
                                    <p class="text-primary">Confirmed</p>
                                @elseif($transaction->state == 'WRK')
                                    <p class="text-success">Processed</p>
                                @elseif($transaction->state == 'DLV')
                                    <p class="text-success">On Delivery</p>
                                @elseif($transaction->state == 'EXP')
                                    <p class="text-danger">Expired</p>
                                @endif
                            </div>
                            <div class="col-12 col-md-2 text-right">
                                <a href="#" class="btn btn-block btn-outline-warning rounded-pill" data-toggle="modal" data-target="#view-detail-{{ $transaction->order_number }}">View Detail</a>
                            </div>
                        </div>
                    </div>
                </div>
                @endforeach
               
            </div>
        </div>
    </div>
@endsection

@push('modal')

<!-- View Detail -->
    @foreach($transactions as $key => $transaction)
    @php 
        $order_number = $transaction->order_number;
    @endphp
         @include('user.components.transaction_detail2', compact('transaction', 'order_number'))
    @endforeach

@endpush

resources/views/user/profile.blade.php
@extends('layouts.web')

@section('content')
    @include('user.components.nav_menu')
    <div class="p-4">
        @if (session('status'))
        <div class="alert alert-primary alert-dismissible fade show" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                <span class="sr-only">Close</span>
            </button>
            {{ session('status') }}
        </div>
        @endif
        <h5 class="font-weight-bold mb-3">Basic Information</h5>
        <div>
            <span class="text-muted">Nama Lengkap</span>
            <p>{{ ucwords(Auth::guard('web')->user()->full_name) }}</p>
        </div>
        <div>
            <span class="text-muted">Email Address</span>
            <p>{{ Auth::guard('web')->user()->email }}</p>
        </div>
        <div>
            <span class="text-muted">Phone Number</span>
            <p>{{ Auth::guard('web')->user()->phone }}</p>
        </div>
        <a href="#" class="btn btn-warning" data-toggle="modal" data-target="#basic-info"><i class="fas fa-edit"></i> Edit Information</a>
        <hr>
        @if (session('password'))
        <div class="alert alert-primary alert-dismissible fade show" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                <span class="sr-only">Close</span>
            </button>
            {{ session('password') }}
        </div>
        @endif
        <h5 class="font-weight-bold mb-3">Change Password</h5>
        <div class="row">
            <div class="col-md-6">
                <div class="alert alert-secondary" role="alert">
                    <p class="mb-0">If you wish to change the password to access your account, Your current e-mail address is <b>{{ Auth::guard('web')->user()->email }}</b></p>
                </div>
            </div>
        </div>
        <form action="{{ route('dashboard.password.update') }}" method="POST">
            @csrf
            <input type="hidden" name="_method" value="PUT">
            <div class="form-group row">
                <label for="" class="text-muted col-sm-12">Current Password</label>
                <div class="col-sm-3">
                    <input type="password" name="password_current" class="form-control">
                </div>
            </div>
            <div class="form-group row">
                <label for="" class="text-muted col-sm-12">New Password</label>
                <div class="col-sm-3">
                    <input type="password" name="password_new" class="form-control">
                </div>
            </div>
            <div class="form-group row">
                <label for="" class="text-muted col-sm-12">Confirm New Password</label>
                <div class="col-sm-3">
                    <input type="password" name="password_confirm" class="form-control">
                </div>
            </div>
            <div class="form-group">
                <button type="submit" class="btn btn-warning">Change Password</button>
            </div>
        </form>
    </div>
@endsection

@push('modal')

<!-- View Detail -->
<div class="modal fade" id="basic-info" tabindex="-1" role="dialog" aria-labelledby="modelTitleId" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content p-4">
            <div class="modal-header border-0 p-0 pb-4">
                <div class="w-100">
                    <div class="row">
                        <div class="col-lg-9 mr-auto">
                            <h3 class="modal-title font-weight-bold">Edit Basic Information</h3>
                        </div>
                        <div class="col-lg-2 text-right">
                            <button type="button" class="close py-2" data-dismiss="modal" aria-label="Close">
                                <i class="fas fa-times"></i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-body p-0">
                <div class="row">
                    <div class="col-lg-12">
                        <div class="alert alert-secondary">
                            You can only change your phone number
                        </div>
                    </div>
                </div>
                <form action="{{ route('dashboard.profile.update') }}" method="POST">
                    @csrf
                    <input type="hidden" name="_method" value="PUT">
                    <div class="form-group">
                        <label for="" class="text-muted">Nama Lengkap</label>
                        <p>{{ ucwords(Auth::guard('web')->user()->full_name) }}</p>
                    </div>
                    <div class="form-group">
                        <label for="" class="text-muted">Email Address</label>
                        <p>{{ Auth::guard('web')->user()->email }}</p>
                    </div>
                    <div class="form-group">
                        <label for="" class="text-muted">Phone Number</label>
                        <input type="text" name="phone" class="form-control">
                    </div>
                    <button class="btn btn-block btn-lg btn-warning">Save Change</button>
                </form>
            </div>
        </div>
    </div>
</div>

@endpush